export const createSubscribeToTimingObject = (scheduleAudioBufferSourceNode) => (audioWorkletNode, context, createAudioBufferSourceNode, timingObject) => {
    let hasPendingUpdate = false;
    let isSendingUpdate = false;
    const scheduleUpdate = () => {
        hasPendingUpdate = false;
        scheduleAudioBufferSourceNode(audioWorkletNode, context, createAudioBufferSourceNode, timingObject).then(() => {
            if (hasPendingUpdate) {
                scheduleUpdate();
            }
            else {
                isSendingUpdate = false;
            }
        });
    };
    const listener = () => {
        if (isSendingUpdate) {
            hasPendingUpdate = true;
        }
        else {
            isSendingUpdate = true;
            scheduleUpdate();
        }
    };
    timingObject.addEventListener('change', listener);
    return () => timingObject.removeEventListener('change', listener);
};
//# sourceMappingURL=subscribe-to-timing-object.js.map