(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@babel/runtime/helpers/asyncToGenerator'), require('@babel/runtime/regenerator')) :
    typeof define === 'function' && define.amd ? define(['exports', '@babel/runtime/helpers/asyncToGenerator', '@babel/runtime/regenerator'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global.timedAudioBufferSourceNodeAudioWorklet = {}, global._asyncToGenerator, global._regeneratorRuntime));
})(this, (function (exports, _asyncToGenerator, _regeneratorRuntime) { 'use strict';

    var createConvertToContextFrame = function createConvertToContextFrame(performance) {
      return function (context, timestamp) {
        if (performance === null) {
          throw new Error('Performance is not available.');
        }
        return Math.round((context.currentTime - performance.now() / 1000 + timestamp) * context.sampleRate);
      };
    };

    var createPerformance = function createPerformance() {
      return typeof window === 'undefined' ? null : typeof window.performance === 'undefined' ? null : window.performance;
    };

    var createScheduleAudioBufferSourceNode = function createScheduleAudioBufferSourceNode(convertToContextFrame) {
      return function (audioWorkletNode, context, createAudioBufferSourceNode, timingObject) {
        var audioBuffer = new AudioBuffer({
          length: 3,
          sampleRate: context.sampleRate
        });
        var audioBufferSourceNode = createAudioBufferSourceNode(context);
        var _timingObject$query = timingObject.query(),
          position = _timingObject$query.position,
          timestamp = _timingObject$query.timestamp,
          velocity = _timingObject$query.velocity;
        audioBuffer.copyToChannel(new Float32Array([position, convertToContextFrame(context, timestamp), velocity]), 0);
        audioBufferSourceNode.buffer = audioBuffer;
        var promise = new Promise(function (resolve) {
          return audioBufferSourceNode.addEventListener('ended', function () {
            return resolve();
          }, {
            once: true
          });
        });
        audioBufferSourceNode.connect(audioWorkletNode);
        audioBufferSourceNode.start();
        return promise;
      };
    };

    var createSubscribeToTimingObject = function createSubscribeToTimingObject(scheduleAudioBufferSourceNode) {
      return function (audioWorkletNode, context, createAudioBufferSourceNode, timingObject) {
        var hasPendingUpdate = false;
        var isSendingUpdate = false;
        var scheduleUpdate = function scheduleUpdate() {
          hasPendingUpdate = false;
          scheduleAudioBufferSourceNode(audioWorkletNode, context, createAudioBufferSourceNode, timingObject).then(function () {
            if (hasPendingUpdate) {
              scheduleUpdate();
            } else {
              isSendingUpdate = false;
            }
          });
        };
        var listener = function listener() {
          if (isSendingUpdate) {
            hasPendingUpdate = true;
          } else {
            isSendingUpdate = true;
            scheduleUpdate();
          }
        };
        timingObject.addEventListener('change', listener);
        return function () {
          return timingObject.removeEventListener('change', listener);
        };
      };
    };

    // This is the minified and stringified code of the timed-audio-buffer-source-node-audio-worklet-processor package.
    var worklet = "(()=>{var e={783:function(e,t,r){!function(e,t,r,o,n,u,s,p){\"use strict\";function i(e,t,r){return t=u(t),n(e,l()?Reflect.construct(t,[],u(e).constructor):t.apply(e,r))}function l(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(e){}return(l=function(){return!!e})()}var a=function(n){function u(e){var o,n,s=e.numberOfInputs,p=e.numberOfOutputs,l=e.outputChannelCount,a=e.processorOptions;r(this,u);var f=\"object\"===t(a)&&null!==a&&\"buffer\"in a?a.buffer:null;if(!(null===f||Array.isArray(f)&&f.every((function(e){return e instanceof Float32Array}))))throw new Error(\"The buffer needs to be either null or an array with where each element is a Float32Array.\");if(1!==s)throw new Error(\"The numberOfInputs must be 1.\");if(1!==p)throw new Error(\"The numberOfOutputs must be 1.\");var c=null!==(n=null==f?void 0:f.length)&&void 0!==n?n:1;if(void 0===l||1!==l.length||c!==l[0])throw new Error(\"The outputChannelCount must match the number of channels of the buffer.\");var x=\"object\"===t(a)&&null!==a&&\"position\"in a?a.position:0;if(\"number\"!=typeof x)throw new Error('The position needs to be of type \"number\".');var d=\"object\"===t(a)&&null!==a&&\"timestamp\"in a?a.timestamp:0;if(\"number\"!=typeof d)throw new Error('The timestamp needs to be of type \"number\".');var y=\"object\"===t(a)&&null!==a&&\"velocity\"in a?a.velocity:0;if(![0,1].includes(y))throw new Error(\"The velocity needs to be either 0 or 1.\");return(o=i(this,u))._buffer=f,o._position=x,o._timestamp=d,o._velocity=y,o}return s(u,n),o(u,[{key:\"process\",value:function(t,r){var o=e(t,1)[0],n=e(r,1)[0];if((null==o?void 0:o.length)>0){var u=e(o,1)[0];u.length>1&&(this._position=Math.round(u[0]),this._timestamp=Math.round(u[1]),this._velocity=Math.round(u[2]))}if(null!==this._buffer)for(var s=this._buffer.length,p=0;p<s;p+=1)for(var i=this._buffer[p],l=n[p],a=0;a<128;a+=1){var f=this._position+(currentFrame-this._timestamp+a)*this._velocity;f>=0&&f<i.length&&(l[a]=i[f])}return!0}}])}(p(AudioWorkletProcessor));a.parameterDescriptors=[],registerProcessor(\"timed-audio-buffer-source-node-audio-worklet-processor\",a)}(r(715),r(738),r(383),r(579),r(452),r(72),r(511),r(837))},79:e=>{e.exports=function(e,t){(null==t||t>e.length)&&(t=e.length);for(var r=0,o=new Array(t);r<t;r++)o[r]=e[r];return o},e.exports.__esModule=!0,e.exports.default=e.exports},987:e=>{e.exports=function(e){if(Array.isArray(e))return e},e.exports.__esModule=!0,e.exports.default=e.exports},475:e=>{e.exports=function(e){if(void 0===e)throw new ReferenceError(\"this hasn't been initialised - super() hasn't been called\");return e},e.exports.__esModule=!0,e.exports.default=e.exports},383:e=>{e.exports=function(e,t){if(!(e instanceof t))throw new TypeError(\"Cannot call a class as a function\")},e.exports.__esModule=!0,e.exports.default=e.exports},646:(e,t,r)=>{var o=r(636),n=r(550);e.exports=function(e,t,r){if(n())return Reflect.construct.apply(null,arguments);var u=[null];u.push.apply(u,t);var s=new(e.bind.apply(e,u));return r&&o(s,r.prototype),s},e.exports.__esModule=!0,e.exports.default=e.exports},579:(e,t,r)=>{var o=r(736);function n(e,t){for(var r=0;r<t.length;r++){var n=t[r];n.enumerable=n.enumerable||!1,n.configurable=!0,\"value\"in n&&(n.writable=!0),Object.defineProperty(e,o(n.key),n)}}e.exports=function(e,t,r){return t&&n(e.prototype,t),r&&n(e,r),Object.defineProperty(e,\"prototype\",{writable:!1}),e},e.exports.__esModule=!0,e.exports.default=e.exports},72:e=>{function t(r){return e.exports=t=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)},e.exports.__esModule=!0,e.exports.default=e.exports,t(r)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},511:(e,t,r)=>{var o=r(636);e.exports=function(e,t){if(\"function\"!=typeof t&&null!==t)throw new TypeError(\"Super expression must either be null or a function\");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,\"prototype\",{writable:!1}),t&&o(e,t)},e.exports.__esModule=!0,e.exports.default=e.exports},691:e=>{e.exports=function(e){try{return-1!==Function.toString.call(e).indexOf(\"[native code]\")}catch(t){return\"function\"==typeof e}},e.exports.__esModule=!0,e.exports.default=e.exports},550:e=>{function t(){try{var r=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){})))}catch(r){}return(e.exports=t=function(){return!!r},e.exports.__esModule=!0,e.exports.default=e.exports)()}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},156:e=>{e.exports=function(e,t){var r=null==e?null:\"undefined\"!=typeof Symbol&&e[Symbol.iterator]||e[\"@@iterator\"];if(null!=r){var o,n,u,s,p=[],i=!0,l=!1;try{if(u=(r=r.call(e)).next,0===t){if(Object(r)!==r)return;i=!1}else for(;!(i=(o=u.call(r)).done)&&(p.push(o.value),p.length!==t);i=!0);}catch(e){l=!0,n=e}finally{try{if(!i&&null!=r.return&&(s=r.return(),Object(s)!==s))return}finally{if(l)throw n}}return p}},e.exports.__esModule=!0,e.exports.default=e.exports},752:e=>{e.exports=function(){throw new TypeError(\"Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.\")},e.exports.__esModule=!0,e.exports.default=e.exports},452:(e,t,r)=>{var o=r(738).default,n=r(475);e.exports=function(e,t){if(t&&(\"object\"===o(t)||\"function\"==typeof t))return t;if(void 0!==t)throw new TypeError(\"Derived constructors may only return object or undefined\");return n(e)},e.exports.__esModule=!0,e.exports.default=e.exports},636:e=>{function t(r,o){return e.exports=t=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e},e.exports.__esModule=!0,e.exports.default=e.exports,t(r,o)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},715:(e,t,r)=>{var o=r(987),n=r(156),u=r(122),s=r(752);e.exports=function(e,t){return o(e)||n(e,t)||u(e,t)||s()},e.exports.__esModule=!0,e.exports.default=e.exports},45:(e,t,r)=>{var o=r(738).default;e.exports=function(e,t){if(\"object\"!=o(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var n=r.call(e,t||\"default\");if(\"object\"!=o(n))return n;throw new TypeError(\"@@toPrimitive must return a primitive value.\")}return(\"string\"===t?String:Number)(e)},e.exports.__esModule=!0,e.exports.default=e.exports},736:(e,t,r)=>{var o=r(738).default,n=r(45);e.exports=function(e){var t=n(e,\"string\");return\"symbol\"==o(t)?t:t+\"\"},e.exports.__esModule=!0,e.exports.default=e.exports},738:e=>{function t(r){return e.exports=t=\"function\"==typeof Symbol&&\"symbol\"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&\"function\"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?\"symbol\":typeof e},e.exports.__esModule=!0,e.exports.default=e.exports,t(r)}e.exports=t,e.exports.__esModule=!0,e.exports.default=e.exports},122:(e,t,r)=>{var o=r(79);e.exports=function(e,t){if(e){if(\"string\"==typeof e)return o(e,t);var r=Object.prototype.toString.call(e).slice(8,-1);return\"Object\"===r&&e.constructor&&(r=e.constructor.name),\"Map\"===r||\"Set\"===r?Array.from(e):\"Arguments\"===r||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(r)?o(e,t):void 0}},e.exports.__esModule=!0,e.exports.default=e.exports},837:(e,t,r)=>{var o=r(72),n=r(636),u=r(691),s=r(646);function p(t){var r=\"function\"==typeof Map?new Map:void 0;return e.exports=p=function(e){if(null===e||!u(e))return e;if(\"function\"!=typeof e)throw new TypeError(\"Super expression must either be null or a function\");if(void 0!==r){if(r.has(e))return r.get(e);r.set(e,t)}function t(){return s(e,arguments,o(this).constructor)}return t.prototype=Object.create(e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),n(t,e)},e.exports.__esModule=!0,e.exports.default=e.exports,p(t)}e.exports=p,e.exports.__esModule=!0,e.exports.default=e.exports}},t={};function r(o){var n=t[o];if(void 0!==n)return n.exports;var u=t[o]={exports:{}};return e[o].call(u.exports,u,u.exports,r),u.exports}r.n=e=>{var t=e&&e.__esModule?()=>e.default:()=>e;return r.d(t,{a:t}),t},r.d=(e,t)=>{for(var o in t)r.o(t,o)&&!r.o(e,o)&&Object.defineProperty(e,o,{enumerable:!0,get:t[o]})},r.o=(e,t)=>Object.prototype.hasOwnProperty.call(e,t),(()=>{\"use strict\";r(783)})()})();"; // tslint:disable-line:max-line-length

    var blob = new Blob([worklet], {
      type: 'application/javascript; charset=utf-8'
    });
    var addTimedAudioBufferSourceNodeAudioWorkletModule = /*#__PURE__*/function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(addAudioWorkletModule) {
        var url;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              url = URL.createObjectURL(blob);
              _context.prev = 1;
              _context.next = 4;
              return addAudioWorkletModule(url);
            case 4:
              _context.prev = 4;
              URL.revokeObjectURL(url);
              return _context.finish(4);
            case 7:
            case "end":
              return _context.stop();
          }
        }, _callee, null, [[1,, 4, 7]]);
      }));
      return function addTimedAudioBufferSourceNodeAudioWorkletModule(_x) {
        return _ref.apply(this, arguments);
      };
    }();
    var convertToContextFrame = createConvertToContextFrame(createPerformance());
    var subscribeToTimingObject = createSubscribeToTimingObject(createScheduleAudioBufferSourceNode(convertToContextFrame));
    function createTimedAudioBufferSourceNodeAudioWorkletNode(audioWorkletNodeConstructor, context, createAudioBufferSourceNode) {
      var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
      var _a, _b;
      var _options$buffer = options.buffer,
        buffer = _options$buffer === void 0 ? null : _options$buffer;
      if (buffer instanceof AudioBuffer && buffer.sampleRate !== context.sampleRate) {
        throw new TypeError('The AudioBuffer must have the same sampleRate as the AudioContext.');
      }
      var _options$timingObject = options.timingObject,
        timingObject = _options$timingObject === void 0 ? null : _options$timingObject;
      var _ref2 = (_a = timingObject === null || timingObject === void 0 ? void 0 : timingObject.query()) !== null && _a !== void 0 ? _a : {},
        _ref2$position = _ref2.position,
        position = _ref2$position === void 0 ? 0 : _ref2$position,
        _ref2$timestamp = _ref2.timestamp,
        timestamp = _ref2$timestamp === void 0 ? 0 : _ref2$timestamp,
        _ref2$velocity = _ref2.velocity,
        velocity = _ref2$velocity === void 0 ? 0 : _ref2$velocity;
      var audioWorkletNode = new audioWorkletNodeConstructor(context, 'timed-audio-buffer-source-node-audio-worklet-processor', {
        numberOfInputs: 1,
        numberOfOutputs: 1,
        outputChannelCount: [(_b = buffer === null || buffer === void 0 ? void 0 : buffer.numberOfChannels) !== null && _b !== void 0 ? _b : 1],
        processorOptions: {
          buffer: buffer instanceof AudioBuffer ? Array.from({
            length: buffer.numberOfChannels
          }, function (_, channel) {
            return buffer.getChannelData(channel);
          }) : null,
          position: position,
          timestamp: convertToContextFrame(context, timestamp),
          velocity: velocity
        }
      });
      var removeListener = null;
      Object.defineProperties(audioWorkletNode, {
        port: {
          get: function get() {
            throw new Error("The port of a TimedAudioBufferSourceNodeAudioWorkletNode can't be accessed.");
          }
        },
        timingObject: {
          get: function get() {
            return timingObject;
          },
          set: function set(value) {
            removeListener === null || removeListener === void 0 ? void 0 : removeListener();
            removeListener = null;
            if (value === null) {
              timingObject = value;
            } else {
              throw new TypeError('A TimingObject can only be set in the constructor.');
            }
          }
        }
      });
      if (timingObject !== null) {
        removeListener = subscribeToTimingObject(audioWorkletNode, context, createAudioBufferSourceNode, timingObject);
      }
      return audioWorkletNode;
    }

    exports.addTimedAudioBufferSourceNodeAudioWorkletModule = addTimedAudioBufferSourceNodeAudioWorkletModule;
    exports.createTimedAudioBufferSourceNodeAudioWorkletNode = createTimedAudioBufferSourceNodeAudioWorkletNode;

}));
